import static java.lang.System.err;

public class ClassBrowser {
	public static void main(String[] args) {
		ClassBrowser cb = new ClassBrowser();
		for(String arg : args) {
			try {
				Class startClass = Class.forName(arg);
				cb.printType(startClass, 0, basic);
			} catch (ClassNotFoundException e) {
				err.println(e); //report the error
			}
		}
	}
	
	// by default print on standard output
	private java.io.PrintStream out = System.out;
		
	// used in printTyp() for labelling type names
	private static String[] 
		basic = { "class", "interface" },
		supercl = { "extends", "implements" },
		iFace = { null, "extends" };	
		
	private void printType(Class type, int depth, String[] lables) {
		if (type == null) // stop recursion -- no supertype
			return;
		// print this type
		for (int i = 0; i < depth; i++)
			out.print("  ");
		out.print(lables[type.isInterface() ? 1 : 0] + " " );
		out.println(type.getName());
		
		// print out all interfaces this class implements
		Class[] interfaces = type.getInterfaces();
		for (int i = 0; i < interfaces.length; i++)
			printType(interfaces[i], depth + 1, 
						type.isInterface() ? iFace : supercl);
		
		// recurse on the superclass
		printType(type.getSuperclass(), depth + 1, supercl);
	}
	
}
		
		
		